/*
 Author: 	Raymond L. Watrous
		Department of Computer and Information Science
		University of Pennsylvania,
		Philadelphia,PA 19104
							 December, 1988.

		Department of Computer Science
		University of Toronto,
		Toronto, Ontario M5S1A4
							 September, 1990.

 Copyright (C) 1988, Trustees of the University of Pennsylvania.
 Copyright (C) 1990, Trustees of the University of Toronto.

 Permission is granted to any individual or institution to use, copy, or
 redistribute this software so long as it is not sold for profit, provided this
 copyright notice is retained. 

			   NO WARRANTY

  Because GRADSIM is licensed free of charge, absolutely NO WARRANTY is
  provided. GRADSIM is supplied "as is" without warranty of any kind, either
  expressed or implied, including, but not limited to, the implied warranties
  of merchantability and fitness for a particular purpose. The entire risk as
  to the quality and performance of the program is with you. Should the
  program prove defective, you assume the cost of all necessary servicing,
  repair or correction.

  In no event will Raymond L. Watrous, the University of Pennsylvania,
  or the University of Toronto be liable for damages, including any lost profits,
  lost monies, or other special, incidental or consequential damages arising out of
  the use or inability to use this program.

*/

/*
	sig_targ.c

                sigmoid target function computation

*/

#include <math.h>


double target_func(extent,xi,xi2,mag)
double extent, xi, xi2, mag;
/*      Computes target value based on sigmoid function given
extent through buffer, and sign of target */
{
double sig,x;

x = mag * (extent - xi);
sig =  1.000 /(1.000 + exp(-x));
x = mag * (extent - xi2);
sig +=  1.000 /(1.000 + exp(x)) - 1.00000;
return(0.45 * sig);
}



double target_part_xi(extent,sign,xi,mag)
double extent, sign, xi, mag;
/*      Computes target value based on Gaussian function given
extent through buffer, and sign of target */
{
double sig,x;

x = mag * (extent - xi);
sig =  1.000 /(1.000 + exp(-x));
return(-0.500 * sign * 0.900 * sig * (1.00 - sig) * mag);
}



double target_part_xi2(extent,sign,xi2,mag)
double extent, sign, xi2, mag;
/*      Computes target value based on Gaussian function given
extent through buffer, and sign of target */
{
return(-target_part_xi(extent,sign,xi2,mag));
}



double target_part_mag(extent,sign,xi,xi2,mag)
double extent, sign, xi, xi2, mag;
/*      Computes target value based on Gaussian function given
extent through buffer, and sign of target */
{
double sig,x,del;

x = mag * (extent - xi);
sig =  1.000 /(1.000 + exp(-x));
del = sig * (1.00 - sig) * (extent - xi);
x = mag * (extent - xi2);
sig =  1.000 /(1.000 + exp(-x));
del += sig * (1.00 - sig) * (xi2 - extent);
return(0.4500 * sign * del);
}


