/*

	io_tvar.c


	I/O module for time-varying signals

*/



int read_in_data(desc,od)
struct map_entry *desc;
double od[MAX_DURATION][MAX_NUM_UNITS];
/*
	Tries to read maximum bytes from file and returns actual
	length - error if MAX is reached. If OK converts to scaled
	double data in output[][] buffer
*/
{
FILE *fp;
register int time,count,chan;
#ifdef CONTEXT
register int place;
#endif

if ((fp=fopen(desc->filename,"r")) == NULL)
	{
	fprintf (stderr,"Error, could not open %s\n", desc->filename);
	exit(1);
	}

if ((count = fread(input,ByteCount,MAX_DURATION,fp)) == MAX_DURATION)
	{
	fprintf(stderr,"Read Max Byte Count - %d - leaving\n",count);
	exit(1);
	}
fclose(fp);

for (time=0; time<count; time++)
	{
	for (chan=0; chan<INPUT_UNITS; chan++)
		od[time][chan] = 
			((double) (input[time][chan]
				   & EIGHT_BITS))/EIGHT_BITS + ENERGY_OFFSET;
#ifdef CONTEXT
#ifdef CTX_CODED
	for (place = desc->context, chan=INPUT_UNITS; chan<INPUT_UNITS + CONTEXT_UNITS; chan++, place /= 2)
		od[time][chan] = place % 2;
#else
	for (chan=INPUT_UNITS; chan<INPUT_UNITS + CONTEXT_UNITS; chan++)
		od[time][chan] = 0.0000;
	od[time][INPUT_UNITS + desc->context] = 1.0000;
#endif
#endif
	}
return(count);
}

